namespace dnnl {
namespace impl {
namespace gpu {
namespace intel {
namespace ocl {
const char *ocl_types_specific_header = R"==(/*******************************************************************************)==""\n"
R"==(* Copyright 2025 Intel Corporation)==""\n"
R"==(*)==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License");)==""\n"
R"==(* you may not use this file except in compliance with the License.)==""\n"
R"==(* You may obtain a copy of the License at)==""\n"
R"==(*)==""\n"
R"==(* http:)==""\n"
R"==(*)==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software)==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS,)==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.)==""\n"
R"==(* See the License for the specific language governing permissions and)==""\n"
R"==(* limitations under the License.)==""\n"
R"==(*******************************************************************************/)==""\n"
R"==(#ifndef GPU_INTEL_OCL_OCL_TYPES_SPECIFIC_H)==""\n"
R"==(#define GPU_INTEL_OCL_OCL_TYPES_SPECIFIC_H)==""\n"
R"==(#ifdef SRC_DATA_T)==""\n"
R"==(#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2))==""\n"
R"==(#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4))==""\n"
R"==(#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8))==""\n"
R"==(#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16))==""\n"
R"==(#define AS_SRC_DATA_T CONCAT2(as_, SRC_DATA_T))==""\n"
R"==(#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T))==""\n"
R"==(#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T))==""\n"
R"==(#define AS_SRC_DATA8_T CONCAT2(as_, SRC_DATA8_T))==""\n"
R"==(#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T))==""\n"
R"==(#if SRC_DT_U8)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(x))==""\n"
R"==(#define SRC_TO_REF8(x) convert_float8(x))==""\n"
R"==(#define REF_TO_SRC(x) convert_uchar(x))==""\n"
R"==(#elif SRC_DT_S8)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(x))==""\n"
R"==(#define SRC_TO_REF8(x) convert_float8(x))==""\n"
R"==(#define REF_TO_SRC(x) convert_char(x))==""\n"
R"==(#elif SRC_DT_BF16)==""\n"
R"==(#define SRC_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define SRC_TO_REF8(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_SRC(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif SRC_DT_F16)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(x))==""\n"
R"==(#define SRC_TO_REF8(x) convert_float8(x))==""\n"
R"==(#define REF_TO_SRC(x) convert_half(x))==""\n"
R"==(#elif SRC_DT_BF8)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define SRC_TO_REF8(x) convert_float8(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define REF_TO_SRC(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif SRC_DT_HF8)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define SRC_TO_REF8(x) convert_float8(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define REF_TO_SRC(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif SRC_DT_F4_E2M1)==""\n"
R"==(#define SRC_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define SRC_TO_REF8(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_SRC(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif SRC_DT_F4_E3M0)==""\n"
R"==(#define SRC_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define SRC_TO_REF8(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_SRC(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif SRC_DT_U4)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(x))==""\n"
R"==(#elif SRC_DT_S4)==""\n"
R"==(#define SRC_TO_REF(x) convert_float(cvt_s4_to_f32(x)))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_TO_REF(x) (x))==""\n"
R"==(#define SRC_TO_REF8(x) (x))==""\n"
R"==(#define REF_TO_SRC(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if SRC_DT_BF16)==""\n"
R"==(#define TO_SRC(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif SRC_DT_F16)==""\n"
R"==(#define TO_SRC(x) convert_half(x))==""\n"
R"==(#elif SRC_DT_BF8)==""\n"
R"==(#define TO_SRC(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif SRC_DT_HF8)==""\n"
R"==(#define TO_SRC(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif SRC_DT_F4_E2M1)==""\n"
R"==(#define TO_SRC(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif SRC_DT_F4_E3M0)==""\n"
R"==(#define TO_SRC(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif SRC_DT_U8)==""\n"
R"==(#define TO_SRC(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif SRC_DT_S8)==""\n"
R"==(#define TO_SRC(x) convert_char_sat_rte(x))==""\n"
R"==(#elif SRC_DT_S32)==""\n"
R"==(#define TO_SRC(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_SRC(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef A_DATA_T)==""\n"
R"==(#if A_DT_BF16)==""\n"
R"==(#define A_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define A_TO_REF8(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_A(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif A_DT_BF8)==""\n"
R"==(#define A_TO_REF(x) cvt_f8_e5m2_to_hf(x))==""\n"
R"==(#define A_TO_REF8(x) cvt_f8_e5m2_to_hf(x))==""\n"
R"==(#define REF_TO_A(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif A_DT_HF8)==""\n"
R"==(#define A_TO_REF(x) cvt_f8_e4m3_to_hf(x))==""\n"
R"==(#define A_TO_REF8(x) cvt_f8_e4m3_to_hf(x))==""\n"
R"==(#define REF_TO_A(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif A_DT_F4_E2M1)==""\n"
R"==(#define A_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define A_TO_REF8(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_A(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif A_DT_F4_E3M0)==""\n"
R"==(#define A_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define A_TO_REF8(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_A(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#else)==""\n"
R"==(#define A_TO_REF(x) (x))==""\n"
R"==(#define A_TO_REF8(x) (x))==""\n"
R"==(#define REF_TO_A(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if A_DT_BF16)==""\n"
R"==(#define TO_A(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif A_DT_BF8)==""\n"
R"==(#define TO_A(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif A_DT_HF8)==""\n"
R"==(#define TO_A(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif A_DT_F4_E2M1)==""\n"
R"==(#define TO_A(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif A_DT_F4_E3M0)==""\n"
R"==(#define TO_A(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif A_DT_U8)==""\n"
R"==(#define TO_A(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif A_DT_S8)==""\n"
R"==(#define TO_A(x) convert_char_sat_rte(x))==""\n"
R"==(#elif A_DT_S32)==""\n"
R"==(#define TO_A(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_A(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef WEI_DATA_T)==""\n"
R"==(#if WEI_DT_BF16)==""\n"
R"==(#define WEI_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_WEI(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif WEI_DT_BF8)==""\n"
R"==(#define WEI_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define REF_TO_WEI(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif WEI_DT_HF8)==""\n"
R"==(#define WEI_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define REF_TO_WEI(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif WEI_DT_F4_E2M1)==""\n"
R"==(#define WEI_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_WEI(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif WEI_DT_F4_E3M0)==""\n"
R"==(#define WEI_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_WEI(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif WEI_DT_S8)==""\n"
R"==(#define WEI_TO_REF(x) convert_int_sat_rte(x))==""\n"
R"==(#define REF_TO_WEI(x) convert_char_sat_rte(x))==""\n"
R"==(#elif WEI_DT_U8)==""\n"
R"==(#define WEI_TO_REF(x) convert_int_sat_rte(x))==""\n"
R"==(#define REF_TO_WEI(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif WEI_DT_S4)==""\n"
R"==(#define WEI_TO_REF(x) cvt_s4_to_s32(x))==""\n"
R"==(#elif WEI_DT_U4)==""\n"
R"==(#define WEI_TO_REF(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_WEI(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if WEI_DT_BF16)==""\n"
R"==(#define TO_WEI(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif WEI_DT_BF8)==""\n"
R"==(#define TO_WEI(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif WEI_DT_HF8)==""\n"
R"==(#define TO_WEI(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif WEI_DT_F4_E2M1)==""\n"
R"==(#define TO_WEI(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif WEI_DT_F4_E3M0)==""\n"
R"==(#define TO_WEI(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif WEI_DT_U8)==""\n"
R"==(#define TO_WEI(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif WEI_DT_S8)==""\n"
R"==(#define TO_WEI(x) convert_char_sat_rte(x))==""\n"
R"==(#elif WEI_DT_S32)==""\n"
R"==(#define TO_WEI(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_WEI(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef DIFF_WEI_DATA_T)==""\n"
R"==(#if DIFF_WEI_DT_BF16)==""\n"
R"==(#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x))==""\n"
R"==(#else)==""\n"
R"==(#define DIFF_WEI_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_DIFF_WEI(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if DIFF_WEI_DT_BF16)==""\n"
R"==(#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif DIFF_WEI_DT_U8)==""\n"
R"==(#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif DIFF_WEI_DT_S8)==""\n"
R"==(#define TO_DIFF_WEI(x) convert_char_sat_rte(x))==""\n"
R"==(#elif DIFF_WEI_DT_S32)==""\n"
R"==(#define TO_DIFF_WEI(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_DIFF_WEI(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef WEI_DATA_T)==""\n"
R"==(#if WEI_DT_F32 == 1)==""\n"
R"==(#define AS_WEI_DATA_T as_float)==""\n"
R"==(#define BLOCK_WEI_READ intel_sub_group_block_read)==""\n"
R"==(#define BLOCK_WEI_WRITE intel_sub_group_block_write)==""\n"
R"==(#define BLOCK_WEI_DATA_T uint)==""\n"
R"==(#define AS_BLOCK_WEI_DATA_T as_uint)==""\n"
R"==(#define CONVERT_WEI_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_WEI_DATA_T convert_float)==""\n"
R"==(#elif WEI_DT_F16 == 1)==""\n"
R"==(#define AS_WEI_DATA_T as_half)==""\n"
R"==(#define BLOCK_WEI_READ intel_sub_group_block_read_us)==""\n"
R"==(#define BLOCK_WEI_WRITE intel_sub_group_block_write_us)==""\n"
R"==(#define BLOCK_WEI_DATA_T ushort)==""\n"
R"==(#define AS_BLOCK_WEI_DATA_T as_ushort)==""\n"
R"==(#define CONVERT_WEI_FLOAT_T convert_float)==""\n"
R"==(#define CONVERT_WEI_DATA_T convert_half)==""\n"
R"==(#elif WEI_DT_BF16 == 1)==""\n"
R"==(#define AS_WEI_DATA_T as_ushort)==""\n"
R"==(#define BLOCK_WEI_READ intel_sub_group_block_read_us)==""\n"
R"==(#define BLOCK_WEI_WRITE intel_sub_group_block_write_us)==""\n"
R"==(#define BLOCK_WEI_DATA_T ushort)==""\n"
R"==(#define AS_BLOCK_WEI_DATA_T as_ushort)==""\n"
R"==(#define CONVERT_WEI_FLOAT_T cvt_bf16_to_f32)==""\n"
R"==(#define CONVERT_WEI_DATA_T cvt_f32_to_bf16)==""\n"
R"==(#endif)==""\n"
R"==(#if VECT_DT_N == 1)==""\n"
R"==(#define VECT_BLOCK_WEI_READ BLOCK_WEI_READ)==""\n"
R"==(#define VECT_BLOCK_WEI_WRITE BLOCK_WEI_WRITE)==""\n"
R"==(#define AS_VECT_WEI_DATA_T AS_WEI_DATA_T)==""\n"
R"==(#define AS_VECT_BLOCK_WEI_DATA_T AS_BLOCK_WEI_DATA_T)==""\n"
R"==(#define CONVERT_VECT_WEI_FLOAT_T CONVERT_WEI_FLOAT_T)==""\n"
R"==(#define CONVERT_VECT_WEI_DATA_T CONVERT_WEI_DATA_T)==""\n"
R"==(#else)==""\n"
R"==(#define VECT_BLOCK_WEI_READ CONCAT2(BLOCK_WEI_READ, VECT_DT_N))==""\n"
R"==(#define VECT_BLOCK_WEI_WRITE CONCAT2(BLOCK_WEI_WRITE, VECT_DT_N))==""\n"
R"==(#define AS_VECT_WEI_DATA_T CONCAT2(AS_WEI_DATA_T, VECT_DT_N))==""\n"
R"==(#define AS_VECT_BLOCK_WEI_DATA_T CONCAT2(AS_BLOCK_WEI_DATA_T, VECT_DT_N))==""\n"
R"==(#if WEI_DT_BF16 == 1)==""\n"
R"==(#define CONVERT_VECT_WEI_FLOAT_T CONVERT_WEI_FLOAT_T)==""\n"
R"==(#define CONVERT_VECT_WEI_DATA_T CONVERT_WEI_DATA_T)==""\n"
R"==(#else)==""\n"
R"==(#define CONVERT_VECT_WEI_FLOAT_T CONCAT2(CONVERT_WEI_FLOAT_T, VECT_DT_N))==""\n"
R"==(#define CONVERT_VECT_WEI_DATA_T CONCAT2(CONVERT_WEI_DATA_T, VECT_DT_N))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#define LOAD_VECT_WEI(ptr) \)==""\n"
R"==(CONVERT_VECT_WEI_FLOAT_T(AS_VECT_WEI_DATA_T( \)==""\n"
R"==(VECT_BLOCK_WEI_READ((const __global BLOCK_WEI_DATA_T *)(ptr)))))==""\n"
R"==(#define SAVE_VECT_WEI(ptr, val) \)==""\n"
R"==(VECT_BLOCK_WEI_WRITE((__global BLOCK_WEI_DATA_T *)(ptr), \)==""\n"
R"==(AS_VECT_BLOCK_WEI_DATA_T(CONVERT_VECT_WEI_DATA_T(val))))==""\n"
R"==(#endif)==""\n"
R"==(#ifdef B_DATA_T)==""\n"
R"==(#if B_DT_BF16)==""\n"
R"==(#define B_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_B(x) cvt_f32_to_bf16(x))==""\n"
R"==(#define TO_B(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif B_DT_BF8)==""\n"
R"==(#define B_TO_REF(x) cvt_f8_e5m2_to_hf(x))==""\n"
R"==(#define REF_TO_B(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#define TO_B(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif B_DT_HF8)==""\n"
R"==(#define B_TO_REF(x) cvt_f8_e4m3_to_hf(x))==""\n"
R"==(#define REF_TO_B(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#define TO_B(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif B_DT_F4_E2M1)==""\n"
R"==(#define B_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_B(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#define TO_B(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif B_DT_F4_E3M0)==""\n"
R"==(#define B_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_B(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#define TO_B(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif B_DT_U8)==""\n"
R"==(#define B_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_B(x) (x))==""\n"
R"==(#define TO_B(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif B_DT_S8)==""\n"
R"==(#define B_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_B(x) (x))==""\n"
R"==(#define TO_B(x) convert_char_sat_rte(x))==""\n"
R"==(#elif B_DT_S32)==""\n"
R"==(#define B_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_B(x) (x))==""\n"
R"==(#define TO_B(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define B_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_B(x) (x))==""\n"
R"==(#define TO_B(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef BIA_DATA_T)==""\n"
R"==(#define BIA_DATA2_T CONCAT2(BIA_DATA_T, 2))==""\n"
R"==(#if BIA_DT_BF16)==""\n"
R"==(#define BIA_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_BIA(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif BIA_DT_BF8)==""\n"
R"==(#define BIA_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define REF_TO_BIA(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif BIA_DT_HF8)==""\n"
R"==(#define BIA_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define REF_TO_BIA(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif BIA_DT_F4_E2M1)==""\n"
R"==(#define BIA_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_BIA(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif BIA_DT_F4_E3M0)==""\n"
R"==(#define BIA_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_BIA(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#else)==""\n"
R"==(#define BIA_TO_REF(x) (x))==""\n"
R"==(#define REF_TO_BIA(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if BIA_DT_BF16)==""\n"
R"==(#define TO_BIA(x) cvt_f32_to_bf16(x))==""\n"
R"==(#elif BIA_DT_BF8)==""\n"
R"==(#define TO_BIA(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#elif BIA_DT_HF8)==""\n"
R"==(#define TO_BIA(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#elif BIA_DT_F4_E2M1)==""\n"
R"==(#define TO_BIA(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif BIA_DT_F4_E3M0)==""\n"
R"==(#define TO_BIA(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif BIA_DT_U8)==""\n"
R"==(#define TO_BIA(x) convert_uchar_sat_rte(x))==""\n"
R"==(#elif BIA_DT_S8)==""\n"
R"==(#define TO_BIA(x) convert_char_sat_rte(x))==""\n"
R"==(#elif BIA_DT_S32)==""\n"
R"==(#define TO_BIA(x) convert_int_sat_rte(x))==""\n"
R"==(#else)==""\n"
R"==(#define TO_BIA(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef DST_DATA_T)==""\n"
R"==(#define DST_DATA2_T CONCAT2(DST_DATA_T, 2))==""\n"
R"==(#define DST_DATA4_T CONCAT2(DST_DATA_T, 4))==""\n"
R"==(#define DST_DATA8_T CONCAT2(DST_DATA_T, 8))==""\n"
R"==(#define DST_DATA16_T CONCAT2(DST_DATA_T, 16))==""\n"
R"==(#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T))==""\n"
R"==(#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T))==""\n"
R"==(#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T))==""\n"
R"==(#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T))==""\n"
R"==(#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T))==""\n"
R"==(#if DST_DT_F32 || DST_DT_F16)==""\n"
R"==(#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T))==""\n"
R"==(#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T))==""\n"
R"==(#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T))==""\n"
R"==(#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T))==""\n"
R"==(#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T))==""\n"
R"==(#elif DST_DT_BF16)==""\n"
R"==(#define CONVERT_DST_DATA_T TO_DST)==""\n"
R"==(#define CONVERT_DST_DATA2_T TO_DST2)==""\n"
R"==(#define CONVERT_DST_DATA4_T TO_DST4)==""\n"
R"==(#define CONVERT_DST_DATA8_T TO_DST8)==""\n"
R"==(#define CONVERT_DST_DATA16_T TO_DST16)==""\n"
R"==(#else)==""\n"
R"==(#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte))==""\n"
R"==(#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte))==""\n"
R"==(#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte))==""\n"
R"==(#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte))==""\n"
R"==(#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte))==""\n"
R"==(#endif)==""\n"
R"==(#if DST_DT_U8 || DST_DT_S8)==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \)==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr)))==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v)))==""\n"
R"==(#define BLOCK_READ_DST(ptr) \)==""\n"
R"==(AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr)))==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v)))==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \)==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr)))==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v)))==""\n"
R"==(#define BLOCK_READ_DST4(ptr) \)==""\n"
R"==(AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr)))==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v)))==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v)))==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v)))==""\n"
R"==(#elif DST_DT_F16 || DST_DT_BF16)==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v)))==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us2((__global ushort *)ptr, as_ushort2(v)))==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v)))==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v)))==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \)==""\n"
R"==(do { \)==""\n"
R"==(BLOCK_WRITE_DST8(ptr, (v).s01234567); \)==""\n"
R"==(BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \)==""\n"
R"==(} while (0))==""\n"
R"==(#elif DST_DT_S32 || DST_DT_F32)==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write((__global uint *)ptr, as_uint(v)))==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v)))==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v)))==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v)))==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \)==""\n"
R"==(do { \)==""\n"
R"==(BLOCK_WRITE_DST8(ptr, (v).s01234567); \)==""\n"
R"==(BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \)==""\n"
R"==(} while (0))==""\n"
R"==(#elif DST_DT_F16 || DST_DT_BF16)==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v)))==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v)))==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v)))==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \)==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v)))==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \)==""\n"
R"==(do { \)==""\n"
R"==(BLOCK_WRITE_DST8(ptr, (v).s01234567); \)==""\n"
R"==(BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \)==""\n"
R"==(} while (0))==""\n"
R"==(#endif)==""\n"
R"==(#if DST_DT_BF16)==""\n"
R"==(#define DST_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define DST_TO_REF2(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define DST_TO_REF8(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_DST(x) cvt_f32_to_bf16(x))==""\n"
R"==(#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x)))==""\n"
R"==(#elif DST_DT_BF8)==""\n"
R"==(#define DST_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define DST_TO_REF2(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define DST_TO_REF8(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#define REF_TO_DST(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#define REF_TO_DST8(x) cvt_hf_to_f8_e5m2(convert_half8(x)))==""\n"
R"==(#elif DST_DT_HF8)==""\n"
R"==(#define DST_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define DST_TO_REF2(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define DST_TO_REF8(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#define REF_TO_DST(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#define REF_TO_DST8(x) cvt_hf_to_f8_e4m3(convert_half8(x)))==""\n"
R"==(#define DST_DATA_MAX (uchar)0x7B)==""\n"
R"==(#define DST_DATA_MIN (uchar)0xFB)==""\n"
R"==(#elif DST_DT_F4_E2M1)==""\n"
R"==(#define DST_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define DST_TO_REF2(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define DST_TO_REF8(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_DST(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#define REF_TO_DST8(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#define DST_DATA_MAX (uchar)0x07)==""\n"
R"==(#define DST_DATA_MIN (uchar)0x01)==""\n"
R"==(#elif DST_DT_F4_E3M0)==""\n"
R"==(#define DST_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define DST_TO_REF2(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define DST_TO_REF8(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_DST(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#define REF_TO_DST8(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#define DST_DATA_MAX (uchar)0x07)==""\n"
R"==(#define DST_DATA_MIN (uchar)0x08)==""\n"
R"==(#elif DST_DT_F16)==""\n"
R"==(#define REF_TO_DST(x) convert_half(x))==""\n"
R"==(#define DST_TO_REF(x) convert_float(x))==""\n"
R"==(#define DST_TO_REF2(x) convert_float2(x))==""\n"
R"==(#define DST_TO_REF8(x) convert_float8(x))==""\n"
R"==(#elif DST_DT_U8)==""\n"
R"==(#define DST_TO_REF(x) (x))==""\n"
R"==(#define DST_TO_REF2(x) (x))==""\n"
R"==(#define DST_TO_REF8(x) (x))==""\n"
R"==(#define REF_TO_DST(x) convert_uchar(x))==""\n"
R"==(#define REF_TO_DST8(x) convert_uchar8(x))==""\n"
R"==(#elif DST_DT_S8)==""\n"
R"==(#define DST_TO_REF(x) (x))==""\n"
R"==(#define DST_TO_REF2(x) (x))==""\n"
R"==(#define DST_TO_REF8(x) (x))==""\n"
R"==(#define REF_TO_DST(x) convert_char(x))==""\n"
R"==(#define REF_TO_DST8(x) convert_char8(x))==""\n"
R"==(#else)==""\n"
R"==(#define DST_TO_REF(x) (x))==""\n"
R"==(#define DST_TO_REF2(x) (x))==""\n"
R"==(#define DST_TO_REF8(x) (x))==""\n"
R"==(#define REF_TO_DST(x) (x))==""\n"
R"==(#define REF_TO_DST8(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if DST_DT_BF16)==""\n"
R"==(#define TO_DST(x) cvt_f32_to_bf16(convert_float(x)))==""\n"
R"==(#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x)))==""\n"
R"==(#define DST_DATA_FMAX cvt_bf16_to_f32((ushort)0x7F7F))==""\n"
R"==(#define DST_DATA_FMIN cvt_bf16_to_f32((ushort)0x0080))==""\n"
R"==(#define DST_DATA_FLOW cvt_bf16_to_f32((ushort)0xFF7F))==""\n"
R"==(#elif DST_DT_F16)==""\n"
R"==(#define TO_DST(x) convert_half(x))==""\n"
R"==(#define TO_DST2(x) convert_half2(x))==""\n"
R"==(#define TO_DST4(x) convert_half4(x))==""\n"
R"==(#define TO_DST8(x) convert_half8(x))==""\n"
R"==(#define DST_DATA_FMAX convert_float(HALF_MAX))==""\n"
R"==(#define DST_DATA_FMIN convert_float(HALF_MIN))==""\n"
R"==(#define DST_DATA_FLOW -DST_DATA_FMAX)==""\n"
R"==(#elif DST_DT_BF8)==""\n"
R"==(#define TO_DST(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#define TO_DST2(x) cvt_hf_to_f8_e5m2(convert_half2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_hf_to_f8_e5m2(convert_half4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_hf_to_f8_e5m2(convert_half8(x)))==""\n"
R"==(#define TO_DST16(x) cvt_hf_to_f8_e5m2(convert_half16(x)))==""\n"
R"==(#define DST_DATA_FMAX convert_float(cvt_f8_e5m2_to_hf((uchar)0x7B)))==""\n"
R"==(#define DST_DATA_FMIN convert_float(cvt_f8_e5m2_to_hf((uchar)0x04)))==""\n"
R"==(#define DST_DATA_FLOW convert_float(cvt_f8_e5m2_to_hf((uchar)0xFB)))==""\n"
R"==(#elif DST_DT_HF8)==""\n"
R"==(#define TO_DST(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#define TO_DST2(x) cvt_hf_to_f8_e4m3(convert_half2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_hf_to_f8_e4m3(convert_half4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_hf_to_f8_e4m3(convert_half8(x)))==""\n"
R"==(#define TO_DST16(x) cvt_hf_to_f8_e4m3(convert_half16(x)))==""\n"
R"==(#define DST_DATA_FMAX convert_float(cvt_f8_e4m3_to_hf((uchar)0x7E)))==""\n"
R"==(#define DST_DATA_FMIN convert_float(cvt_f8_e4m3_to_hf((uchar)0x08)))==""\n"
R"==(#define DST_DATA_FLOW convert_float(cvt_f8_e4m3_to_hf((uchar)0xFE)))==""\n"
R"==(#elif DST_DT_U4)==""\n"
R"==(#define SET_DOUBLE_HALF_BYTE(x, y, z) set_double_half_byte(x, y, z))==""\n"
R"==(#define TO_DST(x) cvt_f32_to_u4(convert_float(x)))==""\n"
R"==(#define TO_DST2(x) cvt_f32_to_u4(convert_float2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_f32_to_u4(convert_float4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_f32_to_u4(convert_float8(x)))==""\n"
R"==(#define TO_DST16(x) cvt_f32_to_u4(convert_float16(x)))==""\n"
R"==(#define DST_DATA_FMAX 15.0)==""\n"
R"==(#define DST_DATA_FMIN 0.0)==""\n"
R"==(#define DST_DATA_FLOW DST_DATA_FMIN)==""\n"
R"==(#elif DST_DT_S4)==""\n"
R"==(#define SET_DOUBLE_HALF_BYTE(x, y, z) set_double_half_byte(x, y, z))==""\n"
R"==(#define TO_DST(x) cvt_f32_to_s4(convert_float(x)))==""\n"
R"==(#define TO_DST2(x) cvt_f32_to_s4(convert_float2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_f32_to_s4(convert_float4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_f32_to_s4(convert_float8(x)))==""\n"
R"==(#define TO_DST16(x) cvt_f32_to_s4(convert_float16(x)))==""\n"
R"==(#define DST_DATA_FMAX 7.0)==""\n"
R"==(#define DST_DATA_FMIN 1)==""\n"
R"==(#define DST_DATA_FLOW -8.0)==""\n"
R"==(#elif DST_DT_F4_E2M1)==""\n"
R"==(#define SET_DOUBLE_HALF_BYTE(x, y, z) set_double_half_byte(x, y, z))==""\n"
R"==(#define TO_DST(x) cvt_f32_to_f4_e2m1(convert_float(x)))==""\n"
R"==(#define TO_DST2(x) cvt_f32_to_f4_e2m1(convert_float2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_f32_to_f4_e2m1(convert_float4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_f32_to_f4_e2m1(convert_float8(x)))==""\n"
R"==(#define TO_DST16(x) cvt_f32_to_f4_e2m1(convert_float16(x)))==""\n"
R"==(#define DST_DATA_FMAX 6.0)==""\n"
R"==(#define DST_DATA_FMIN 1.0)==""\n"
R"==(#define DST_DATA_FLOW -6.0)==""\n"
R"==(#elif DST_DT_F4_E3M0)==""\n"
R"==(#define SET_DOUBLE_HALF_BYTE(x, y, z) set_double_half_byte(x, y, z))==""\n"
R"==(#define TO_DST(x) cvt_f32_to_f4_e3m0(convert_float(x)))==""\n"
R"==(#define TO_DST2(x) cvt_f32_to_f4_e3m0(convert_float2(x)))==""\n"
R"==(#define TO_DST4(x) cvt_f32_to_f4_e3m0(convert_float4(x)))==""\n"
R"==(#define TO_DST8(x) cvt_f32_to_f4_e3m0(convert_float8(x)))==""\n"
R"==(#define TO_DST16(x) cvt_f32_to_f4_e3m0(convert_float16(x)))==""\n"
R"==(#define DST_DATA_FMAX 16.0)==""\n"
R"==(#define DST_DATA_FMIN 0.25)==""\n"
R"==(#define DST_DATA_FLOW -16.0)==""\n"
R"==(#elif DST_DT_U8)==""\n"
R"==(#define TO_DST(x) convert_uchar_sat_rte(x))==""\n"
R"==(#define TO_DST2(x) convert_uchar2_sat_rte(x))==""\n"
R"==(#define TO_DST4(x) convert_uchar4_sat_rte(x))==""\n"
R"==(#define TO_DST8(x) convert_uchar8_sat_rte(x))==""\n"
R"==(#define TO_DST16(x) convert_uchar16_sat_rte(x))==""\n"
R"==(#define DST_DATA_FMAX convert_float(UCHAR_MAX))==""\n"
R"==(#define DST_DATA_FMIN 1)==""\n"
R"==(#define DST_DATA_FLOW 0)==""\n"
R"==(#elif DST_DT_S8)==""\n"
R"==(#define TO_DST(x) convert_char_sat_rte(x))==""\n"
R"==(#define TO_DST2(x) convert_char2_sat_rte(x))==""\n"
R"==(#define TO_DST4(x) convert_char4_sat_rte(x))==""\n"
R"==(#define TO_DST8(x) convert_char8_sat_rte(x))==""\n"
R"==(#define TO_DST16(x) convert_char16_sat_rte(x))==""\n"
R"==(#define DST_DATA_FMAX convert_float(CHAR_MAX))==""\n"
R"==(#define DST_DATA_FMIN 1)==""\n"
R"==(#define DST_DATA_FLOW -DST_DATA_FMAX)==""\n"
R"==(#elif DST_DT_S32)==""\n"
R"==(#define TO_DST(x) convert_int_sat_rte(x))==""\n"
R"==(#define TO_DST2(x) convert_int2_sat_rte(x))==""\n"
R"==(#define TO_DST4(x) convert_int4_sat_rte(x))==""\n"
R"==(#define TO_DST8(x) convert_int8_sat_rte(x))==""\n"
R"==(#define DST_DATA_FMAX convert_float(INT_MAX))==""\n"
R"==(#define DST_DATA_FMIN 1)==""\n"
R"==(#define DST_DATA_FLOW -DST_DATA_FMAX)==""\n"
R"==(#elif DST_DT_F32)==""\n"
R"==(#define TO_DST(x) convert_float(x))==""\n"
R"==(#define TO_DST2(x) convert_float2(x))==""\n"
R"==(#define TO_DST4(x) convert_float4(x))==""\n"
R"==(#define TO_DST8(x) convert_float8(x))==""\n"
R"==(#define DST_DATA_FMAX convert_float(FLT_MAX))==""\n"
R"==(#define DST_DATA_FMIN convert_float(FLT_MIN))==""\n"
R"==(#define DST_DATA_FLOW -DST_DATA_FMAX)==""\n"
R"==(#elif DST_DT_F64)==""\n"
R"==(#define TO_DST(x) convert_double(x))==""\n"
R"==(#define TO_DST2(x) convert_double2(x))==""\n"
R"==(#define TO_DST4(x) convert_double4(x))==""\n"
R"==(#define TO_DST8(x) convert_double8(x))==""\n"
R"==(#define DST_DATA_FMAX convert_float(FLT_MAX))==""\n"
R"==(#define DST_DATA_FMIN convert_float(FLT_MIN))==""\n"
R"==(#define DST_DATA_FLOW -DST_DATA_FMAX)==""\n"
R"==(#else)==""\n"
R"==(#error "Not expected")==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef C_DATA_T)==""\n"
R"==(#define C_DATA8_T CONCAT2(C_DATA_T, 8))==""\n"
R"==(#if C_DT_BF16)==""\n"
R"==(#define C_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define C_TO_REF8(x) cvt_bf16_to_f32(x))==""\n"
R"==(#define REF_TO_C(x) cvt_f32_to_bf16(x))==""\n"
R"==(#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x)))==""\n"
R"==(#elif C_DT_BF8)==""\n"
R"==(#define C_TO_REF(x) cvt_f8_e5m2_to_hf(convert_half(x)))==""\n"
R"==(#define C_TO_REF8(x) cvt_f8_e5m2_to_hf(convert_half8(x)))==""\n"
R"==(#define REF_TO_C(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#define REF_TO_C8(x) cvt_hf_to_f8_e5m2(convert_half8(x)))==""\n"
R"==(#elif C_DT_HF8)==""\n"
R"==(#define C_TO_REF(x) cvt_f8_e4m3_to_hf(convert_half(x)))==""\n"
R"==(#define C_TO_REF8(x) cvt_f8_e4m3_to_hf(convert_half8(x)))==""\n"
R"==(#define REF_TO_C(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#define REF_TO_C8(x) cvt_hf_to_f8_e4m3(convert_half8(x)))==""\n"
R"==(#elif C_DT_F4_E2M1)==""\n"
R"==(#define C_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define C_TO_REF8(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#define REF_TO_C(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#define REF_TO_C8(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif C_DT_F4_E3M0)==""\n"
R"==(#define C_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define C_TO_REF8(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#define REF_TO_C(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#define REF_TO_C8(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#else)==""\n"
R"==(#define C_TO_REF(x) (x))==""\n"
R"==(#define C_TO_REF8(x) (x))==""\n"
R"==(#define REF_TO_C(x) (x))==""\n"
R"==(#define REF_TO_C8(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#if C_DT_BF16)==""\n"
R"==(#define TO_C(x) cvt_f32_to_bf16(x))==""\n"
R"==(#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x)))==""\n"
R"==(#elif C_DT_BF8)==""\n"
R"==(#define TO_C(x) cvt_hf_to_f8_e5m2(convert_half(x)))==""\n"
R"==(#define TO_C8(x) cvt_hf_to_f8_e5m2(convert_half8(x)))==""\n"
R"==(#elif C_DT_HF8)==""\n"
R"==(#define TO_C(x) cvt_hf_to_f8_e4m3(convert_half(x)))==""\n"
R"==(#define TO_C8(x) cvt_hf_to_f8_e4m3(convert_half8(x)))==""\n"
R"==(#elif C_DT_F4_E2M1)==""\n"
R"==(#define TO_C(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#define TO_C8(x) cvt_f32_to_f4_e2m1(x))==""\n"
R"==(#elif C_DT_F4_E3M0)==""\n"
R"==(#define TO_C(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#define TO_C8(x) cvt_f32_to_f4_e3m0(x))==""\n"
R"==(#elif C_DT_F16)==""\n"
R"==(#define TO_C(x) convert_half(x))==""\n"
R"==(#define TO_C8(x) convert_half8(x))==""\n"
R"==(#elif C_DT_U8)==""\n"
R"==(#define TO_C(x) convert_uchar_sat_rte(x))==""\n"
R"==(#define TO_C8(x) convert_uchar8_sat_rte(x))==""\n"
R"==(#elif C_DT_S8)==""\n"
R"==(#define TO_C(x) convert_char_sat_rte(x))==""\n"
R"==(#define TO_C8(x) convert_char8_sat_rte(x))==""\n"
R"==(#elif C_DT_S32)==""\n"
R"==(#define TO_C(x) convert_int_sat_rte(x))==""\n"
R"==(#define TO_C8(x) convert_int8_sat_rte(x))==""\n"
R"==(#elif C_DT_F32)==""\n"
R"==(#define TO_C(x) convert_float(x))==""\n"
R"==(#define TO_C8(x) convert_float8(x))==""\n"
R"==(#elif C_DT_F64)==""\n"
R"==(#define TO_C(x) convert_double(x))==""\n"
R"==(#define TO_C8(x) convert_double8(x))==""\n"
R"==(#else)==""\n"
R"==(#error "Not expected")==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef ACC_DATA_T)==""\n"
R"==(#if ACC_DT_F16)==""\n"
R"==(#define TO_ACC(x) convert_half(x))==""\n"
R"==(#define ACC_TO_REF(x) convert_float(x))==""\n"
R"==(#elif ACC_DT_F32)==""\n"
R"==(#define TO_ACC(x) convert_float(x))==""\n"
R"==(#define ACC_TO_REF(x) convert_float(x))==""\n"
R"==(#elif ACC_DT_F64)==""\n"
R"==(#define TO_ACC(x) convert_double(x))==""\n"
R"==(#define ACC_TO_REF(x) convert_double(x))==""\n"
R"==(#elif ACC_DT_S32)==""\n"
R"==(#define TO_ACC(x) convert_int(x))==""\n"
R"==(#define ACC_TO_REF(x) convert_float(x))==""\n"
R"==(#else)==""\n"
R"==(#error "Unexpected accumulation data type")==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef SUM_DATA_T)==""\n"
R"==(#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2))==""\n"
R"==(#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4))==""\n"
R"==(#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8))==""\n"
R"==(#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16))==""\n"
R"==(#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T))==""\n"
R"==(#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T))==""\n"
R"==(#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T))==""\n"
R"==(#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T))==""\n"
R"==(#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T))==""\n"
R"==(#if SUM_DT_BF16)==""\n"
R"==(#define SUM_TO_REF cvt_bf16_to_f32)==""\n"
R"==(#elif SUM_DT_BF8)==""\n"
R"==(#define SUM_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif SUM_DT_HF8)==""\n"
R"==(#define SUM_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#elif SUM_DT_F4_E2M1)==""\n"
R"==(#define SUM_TO_REF(x) cvt_f4_e2m1_to_f32(x))==""\n"
R"==(#elif SUM_DT_F4_E3M0)==""\n"
R"==(#define SUM_TO_REF(x) cvt_f4_e3m0_to_f32(x))==""\n"
R"==(#else)==""\n"
R"==(#define SUM_TO_REF)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef DST_SCALES_DATA_T)==""\n"
R"==(#if DST_SCALES_DT_HF8)==""\n"
R"==(#define DST_SCALES_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#elif DST_SCALES_DT_BF8)==""\n"
R"==(#define DST_SCALES_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif DST_SCALES_DT_F16)==""\n"
R"==(#define DST_SCALES_TO_REF(x) convert_float(x))==""\n"
R"==(#elif DST_SCALES_DT_BF16)==""\n"
R"==(#define DST_SCALES_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#elif DST_SCALES_DT_E8M0)==""\n"
R"==(#define DST_SCALES_TO_REF(x) cvt_e8m0_to_f32(x))==""\n"
R"==(#else)==""\n"
R"==(#define DST_SCALES_TO_REF(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef WEI_SCALES_DATA_T)==""\n"
R"==(#if WEI_SCALES_DT_HF8)==""\n"
R"==(#define WEI_SCALES_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#elif WEI_SCALES_DT_BF8)==""\n"
R"==(#define WEI_SCALES_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif WEI_SCALES_DT_F16)==""\n"
R"==(#define WEI_SCALES_TO_REF(x) convert_float(x))==""\n"
R"==(#elif WEI_SCALES_DT_BF16)==""\n"
R"==(#define WEI_SCALES_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_SCALES_TO_REF(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef SRC_SCALES_DATA_T)==""\n"
R"==(#if SRC_SCALES_DT_HF8)==""\n"
R"==(#define SRC_SCALES_TO_REF(x) convert_float(cvt_f8_e4m3_to_hf(x)))==""\n"
R"==(#elif SRC_SCALES_DT_BF8)==""\n"
R"==(#define SRC_SCALES_TO_REF(x) convert_float(cvt_f8_e5m2_to_hf(x)))==""\n"
R"==(#elif SRC_SCALES_DT_F16)==""\n"
R"==(#define SRC_SCALES_TO_REF(x) convert_float(x))==""\n"
R"==(#elif SRC_SCALES_DT_BF16)==""\n"
R"==(#define SRC_SCALES_TO_REF(x) cvt_bf16_to_f32(x))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_SCALES_TO_REF(x) (x))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef WEI_ZP_DATA_T)==""\n"
R"==(#if WEI_ZP_DT_S8)==""\n"
R"==(#define WEI_ZP_TO_REF(zp, off) convert_int_sat_rte(zp[off]))==""\n"
R"==(#elif WEI_ZP_DT_U8)==""\n"
R"==(#define WEI_ZP_TO_REF(zp, off) convert_int_sat_rte(zp[off]))==""\n"
R"==(#elif WEI_ZP_DT_S4)==""\n"
R"==(#define WEI_ZP_TO_REF(zp, off) cvt_s4_to_s32(GET_HALF_BYTE(zp, off)))==""\n"
R"==(#elif WEI_ZP_DT_U4)==""\n"
R"==(#define WEI_ZP_TO_REF(zp, off) convert_int_sat_rte(GET_HALF_BYTE(zp, off)))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_ZP_TO_REF(zp, off) (zp[off]))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#ifdef SRC_ZP_DATA_T)==""\n"
R"==(#if SRC_ZP_DT_S8)==""\n"
R"==(#define SRC_ZP_TO_REF(zp, off) convert_int_sat_rte(zp[off]))==""\n"
R"==(#elif SRC_ZP_DT_U8)==""\n"
R"==(#define SRC_ZP_TO_REF(zp, off) convert_int_sat_rte(zp[off]))==""\n"
R"==(#elif SRC_ZP_DT_S4)==""\n"
R"==(#define SRC_ZP_TO_REF(zp, off) cvt_s4_to_s32(GET_HALF_BYTE(zp, off)))==""\n"
R"==(#elif SRC_ZP_DT_U4)==""\n"
R"==(#define SRC_ZP_TO_REF(zp, off) convert_int_sat_rte(GET_HALF_BYTE(zp, off)))==""\n"
R"==(#else)==""\n"
R"==(#define SRC_ZP_TO_REF(zp, off) (zp[off]))==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==(#if SRC_NDIMS == 3)==""\n"
R"==(#define CONV_SRC_OFF(n, c, d, h, w) OFF_MD(SRC, n, c, w, 0, 0, 0))==""\n"
R"==(#elif SRC_NDIMS == 4)==""\n"
R"==(#define CONV_SRC_OFF(n, c, d, h, w) OFF_MD(SRC, n, c, h, w, 0, 0))==""\n"
R"==(#elif SRC_NDIMS == 5)==""\n"
R"==(#define CONV_SRC_OFF(n, c, d, h, w) OFF_MD(SRC, n, c, d, h, w, 0))==""\n"
R"==(#endif)==""\n"
R"==(#if WEI_NDIMS == 3)==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, o, i, w, 0, 0, 0))==""\n"
R"==(#elif WEI_NDIMS == 4)==""\n"
R"==(#if WITH_GROUPS == 0)==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, o, i, h, w, 0, 0))==""\n"
R"==(#else)==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, g, o, i, w, 0, 0))==""\n"
R"==(#endif)==""\n"
R"==(#elif WEI_NDIMS == 5)==""\n"
R"==(#if WITH_GROUPS == 0)==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, o, i, d, h, w, 0))==""\n"
R"==(#else)==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, g, o, i, h, w, 0))==""\n"
R"==(#endif)==""\n"
R"==(#elif WEI_NDIMS == 6)==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, g, o, i, d, h, w))==""\n"
R"==(#endif)==""\n"
R"==(#if DST_NDIMS == 3)==""\n"
R"==(#define CONV_DST_OFF(n, c, d, h, w) OFF_MD(DST, n, c, w, 0, 0, 0))==""\n"
R"==(#elif DST_NDIMS == 4)==""\n"
R"==(#define CONV_DST_OFF(n, c, d, h, w) OFF_MD(DST, n, c, h, w, 0, 0))==""\n"
R"==(#elif DST_NDIMS == 5)==""\n"
R"==(#define CONV_DST_OFF(n, c, d, h, w) OFF_MD(DST, n, c, d, h, w, 0))==""\n"
R"==(#endif)==""\n"
R"==(#if NDIMS == 2)==""\n"
R"==(#define SRC_OFF(x0, x1, d, h, w) \)==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \)==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1))==""\n"
R"==(#if WITH_GROUPS == 1)==""\n"
R"==(#define WEI_OFF(x0, x1, x2, d, h, w) \)==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_OFF(g, x0, x1, d, h, w) \)==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1))==""\n"
R"==(#endif)==""\n"
R"==(#define DST_OFF(x0, x1, d, h, w) \)==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \)==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1))==""\n"
R"==(#elif NDIMS == 3)==""\n"
R"==(#define SRC_OFF(x0, x1, d, h, x2) \)==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \)==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \)==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2))==""\n"
R"==(#if WITH_GROUPS == 1)==""\n"
R"==(#define WEI_OFF(x0, x1, x2, d, h, x3) \)==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \)==""\n"
R"==(+ ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_OFF(g, x0, x1, d, h, x2) \)==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2))==""\n"
R"==(#endif)==""\n"
R"==(#define DST_OFF(x0, x1, d, h, x2) \)==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \)==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \)==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2))==""\n"
R"==(#elif NDIMS == 4)==""\n"
R"==(#define SRC_OFF(x0, x1, d, x2, x3) \)==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \)==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \)==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \)==""\n"
R"==(+ ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3))==""\n"
R"==(#if WITH_GROUPS == 1)==""\n"
R"==(#define WEI_OFF(x0, x1, x2, d, x3, x4) \)==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \)==""\n"
R"==(+ ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \)==""\n"
R"==(+ ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_OFF(g, x1, x2, d, x3, x4) \)==""\n"
R"==((((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \)==""\n"
R"==(+ ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3))==""\n"
R"==(#endif)==""\n"
R"==(#define DST_OFF(x0, x1, d, x2, x3) \)==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \)==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \)==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \)==""\n"
R"==(+ ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3))==""\n"
R"==(#elif NDIMS == 5)==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4) \)==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \)==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \)==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \)==""\n"
R"==(+ ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \)==""\n"
R"==(+ ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4))==""\n"
R"==(#if WITH_GROUPS == 1)==""\n"
R"==(#define WEI_OFF(x0, x1, x2, x3, x4, x5) \)==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \)==""\n"
R"==(+ ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \)==""\n"
R"==(+ ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \)==""\n"
R"==(+ ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5))==""\n"
R"==(#else)==""\n"
R"==(#define WEI_OFF(g, x1, x2, x3, x4, x5) \)==""\n"
R"==((((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \)==""\n"
R"==(+ ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \)==""\n"
R"==(+ ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \)==""\n"
R"==(+ ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \)==""\n"
R"==(+ ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4))==""\n"
R"==(#endif)==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4) \)==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \)==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \)==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \)==""\n"
R"==(+ ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \)==""\n"
R"==(+ ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4))==""\n"
R"==(#endif)==""\n"
R"==(#if SRC_DT_U8 == 1)==""\n"
R"==(#define SRC_DT_ALIAS UCHAR)==""\n"
R"==(#elif SRC_DT_S8 == 1)==""\n"
R"==(#define SRC_DT_ALIAS CHAR)==""\n"
R"==(#elif SRC_DT_F16 == 1)==""\n"
R"==(#define SRC_DT_ALIAS HALF)==""\n"
R"==(#elif SRC_DT_BF16 == 1)==""\n"
R"==(#define SRC_DT_ALIAS BFLOAT)==""\n"
R"==(#elif SRC_DT_F32 == 1)==""\n"
R"==(#define SRC_DT_ALIAS FLOAT)==""\n"
R"==(#elif SRC_DT_F64 == 1)==""\n"
R"==(#define SRC_DT_ALIAS DOUBLE)==""\n"
R"==(#endif)==""\n"
R"==(#if DST_DT_U8 == 1)==""\n"
R"==(#define DST_DT_ALIAS UCHAR)==""\n"
R"==(#elif DST_DT_S8 == 1)==""\n"
R"==(#define DST_DT_ALIAS CHAR)==""\n"
R"==(#elif DST_DT_F16 == 1)==""\n"
R"==(#define DST_DT_ALIAS HALF)==""\n"
R"==(#elif DST_DT_BF16 == 1)==""\n"
R"==(#define DST_DT_ALIAS BFLOAT)==""\n"
R"==(#elif DST_DT_F32 == 1)==""\n"
R"==(#define DST_DT_ALIAS FLOAT)==""\n"
R"==(#elif DST_DT_F64 == 1)==""\n"
R"==(#define DST_DT_ALIAS DOUBLE)==""\n"
R"==(#endif)==""\n"
R"==(#endif)==""\n"
R"==()==";
}
}
}
}
}